/* 
 * File:         group.h
 * 
 * Description:  header for group.c
 * 
 * 
 * This source code is part of kludge3d, and is released under the 
 * GNU General Public License.
 * 
 * 
 */
 

#ifndef GROUP_H
#define GROUP_H

#include <glib.h>

#include "geo.h"

GNode *group_new( Model *m );
void group_delete( GNode *node );
void group_duplicate( GNode *root ) ;

int group_reparent( Model *model, GNode *node, GNode *new_parent );
void group_merge( Model *model, GNode * n );
void group_new_group_from_polys( Model *model, GNode *parent, GSList *polys ) ;


#endif
