/* 
 * File:         mat_preview.h
 * 
 * Description:  header for mat_preview.c
 * 
 * 
 * This source code is part of kludge3d, and is released under the 
 * GNU General Public License.
 * 
 * 
 */

#ifndef MATPREVIEW_H
#define MATPREVIEW_H


#include <gtk/gtk.h>

#include "material.h"

GtkWidget *mat_preview_new( void );

void mat_preview_set_all( GtkWidget *, Material * );
void mat_preview_set_ambient( GtkWidget *, float *ambient );
void mat_preview_set_diffuse( GtkWidget *, float *diffuse );
void mat_preview_set_specular( GtkWidget *, float *specular );
void mat_preview_set_emission( GtkWidget *, float *emission );
void mat_preview_set_shininess( GtkWidget *, float shininess );

#endif
