/* 
 * File:         toolbar.h
 * 
 * Description:  header for toolbar.c
 * 
 * 
 * This source code is part of kludge3d, and is released under the 
 * GNU General Public License.
 * 
 * 
 */
 
#ifndef TOOLBAR_H
#define TOOLBAR_H

#include <gtk/gtk.h>

#define NUM_MOUSE_BUTTONS  7  /* overkill, I know, but I'm sick of this bug */

#define NUM_TOOL_PALETTES	4

typedef enum {
    CM_OBJECT_ADD,
    CM_OBJECT_DEL,
    CM_OBJECT_SEL,
    CM_OBJECT_MOVE,
    CM_OBJECT_ROT,
	CM_OBJECT_SCALE,
    CM_OBJECT_EXTRUDE,
    CM_OBJECT_TEX,
	CM_OBJECT_THIN,
    CM_ZOOM,
    CM_PAN
} ClickModeType;

extern int *click_mode;
extern int tool_palettes[NUM_MOUSE_BUTTONS * NUM_TOOL_PALETTES];

GtkWidget *create_toolbar( void );

#endif
